# goz_takibi_setup.py

import cv2
import numpy as np

def bos(abc):
    pass

yuzCascade = cv2.CascadeClassifier(
    'Cascades/haarcascade_frontalface_default.xml')
gozCascade = cv2.CascadeClassifier(
    'Cascades/haarcascade_lefteye_2splits.xml')
# gozCascade = cv2.CascadeClassifier(
#     'Cascades/haarcascade_eye.xml')

cv2.namedWindow('kare')
cv2.moveWindow('kare',10,10)
cv2.namedWindow('gri_goz2')
cv2.moveWindow('gri_goz2',1350,10)
cv2.namedWindow('esik')
cv2.moveWindow('esik',1350,180)
cv2.namedWindow('tbars')
cv2.moveWindow('tbars',1350,350)
cv2.createTrackbar('altesik','tbars',100,255,bos)
cv2.createTrackbar('ustesik','tbars',250,255,bos)

kamera = cv2.VideoCapture(0)
if cv2.__version__>='4.0.0':
    pass
else:
    kamera.set(3,1280)
    kamera.set(4,768)
dosyaad = '' #''goz_takibi.mp4'
kaydedici = None
while True:
    ok, kare = kamera.read()
    if not ok: break
    altesik = cv2.getTrackbarPos('altesik','tbars')
    ustesik = cv2.getTrackbarPos('ustesik','tbars')
    gri = cv2.cvtColor(kare, cv2.COLOR_BGR2GRAY)
    esik=renkli_goz=gri_goz2=None
    yuzler = yuzCascade.detectMultiScale(
        gri,
        scaleFactor=1.2, # 1.2
        minNeighbors=5,  # 5
        minSize=(20, 20) # 20,20
    )
    for (x,y,w,h) in yuzler:
        cv2.rectangle(kare,(x,y),(x+w,y+h),(255,255,0),2)
        gri_kutu = gri[y:y+h, x:x+w]
        renkli_kutu = kare[y:y+h, x:x+w]
        tamam = False
        gozler = gozCascade.detectMultiScale(
            gri_kutu,
            scaleFactor=1.1,  # 1.1
            minNeighbors=25, # 10
            minSize=(3,3) # 3,3
        )
        for (ex, ey, ew, eh) in gozler:
            gri_goz = gri_kutu[ey:ey+eh,ex:ex+ew]
            renkli_goz = renkli_kutu[ey:ey + eh, ex:ex + ew]
            rh, rw, _ = renkli_goz.shape
            konturlar = cv2.findContours(gri_goz.copy(),
                    cv2.RETR_EXTERNAL,
                    cv2.CHAIN_APPROX_SIMPLE)[-2]
            if len(konturlar)>0:
                # en büyük gözü bul
                kmax = max(konturlar,key=cv2.contourArea)
                # print("kmax: ",kmax)
                alan = cv2.contourArea(kmax) / 2
                print(alan)
                if alan<1500: continue
                (ex2, ey2, ew2, eh2) = cv2.boundingRect(kmax)
                # gözün alt yarısını al
                eh2=int(eh2/2)
                ey2=ey2+eh2
                cv2.rectangle(renkli_goz, (ex2, ey2),
                        (ex2 + ew2, ey2 + eh2), (255, 0, 0), 2)
                # gözün alt yarısının olduğu görüntü
                gri_goz2 = gri_kutu[ey+eh2:ey+eh,ex:ex+ew]
                renkli_goz2 = renkli_kutu[ey + eh2:ey + eh,
                              ex:ex + ew]
                gri_blur=cv2.GaussianBlur(gri_goz2,(11, 11), 3)
                gri_blur=cv2.dilate(gri_blur,(5,5),iterations=3)
                # gri_blur=cv2.erode(gri_blur,(5,5),iterations=1)
                # gözbebeğini bul ve işle
                # _, esik = cv2.threshold(gri_goz2,
                #           120, 255, cv2.THRESH_BINARY_INV)
                # _, esik = cv2.threshold(gri_goz2,
                #           95, 250, cv2.THRESH_BINARY_INV)
                _, esik = cv2.threshold(gri_goz2,
                                altesik, ustesik,
                                cv2.THRESH_BINARY_INV)
                # esik = cv2.adaptiveThreshold(gri_blur,
                #        255,cv2.ADAPTIVE_THRESH_GAUSSIAN_C,
                #        cv2.THRESH_BINARY,altesik*2+3,2)
                konturlar = cv2.findContours(esik,
                                cv2.RETR_TREE,
                                cv2.CHAIN_APPROX_SIMPLE)[-2]
                if len(konturlar)>0:
                    # tamam=True
                    konturlar = sorted(konturlar,
                            key=lambda x: cv2.contourArea(x),
                                       reverse=True)
                    kmax=konturlar[0]
                    (x, y, w, h) = cv2.boundingRect(kmax)
                    # y=y+eh2
                    # cv2.drawContours(renkli_goz2, [kmax],
                    # -1, (0, 0, 255), 1)
                    cv2.rectangle(renkli_goz2, (x, y),
                            (x + w, y + h), (0, 0, 255), 1)
                    cv2.line(renkli_goz2, (x + int(w / 2), 0),
                            (x + int(w / 2), rh), (0, 255, 0), 1)
                    cv2.line(renkli_goz2, (0, y + int(h / 2)),
                            (rw, y + int(h / 2)), (0, 255, 0), 1)

    # if tamam:
    if renkli_goz is not None:
        cv2.imshow('kare',kare)
    if gri_goz2 is not None:
        cv2.imshow('gri_goz2',gri_goz2)
    if esik is not None:
        cv2.imshow('esik',esik)

    if kaydedici is None and dosyaad is not None:
        fourcc = cv2.VideoWriter_fourcc(*"mp4v")  # .mp4
        kaydedici = cv2.VideoWriter(dosyaad, fourcc, 24.0,
                    (kare.shape[1], kare.shape[0]), True)
    if kaydedici is not None:
        kaydedici.write(kare)

    k = cv2.waitKey(10) & 0xff
    if k == 27 or k==ord('q'): # press 'ESC' or 'q' to quit
        break

kamera.release()
cv2.destroyAllWindows()
